VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RegistryObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' A Visual Basic Registry Access Library

' If you wish to give credit: Nathan Moschkin  (nmosch@tampabay.rr.com)
' Copyright (C) 1999, 2000 Nathan Moschkin.

' If you make changes, be very sure you comment your code!!  :-)
'

' Published February 2000

Option Explicit

' '  Private Declares Space  ' '

' Windows Registry Root Key Constants

Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const HKEY_CURRENT_CONFIG = &H80000005
Private Const HKEY_CURRENT_USER = &H80000001
Private Const HKEY_DYN_DATA = &H80000006
Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const HKEY_PERFORMANCE_DATA = &H80000004
Private Const HKEY_USERS = &H80000003

' Registry Storage Type Constants

Private Const REG_BINARY = 3
Private Const REG_DWORD = 4
Private Const REG_DWORD_BIG_ENDIAN = 5
Private Const REG_DWORD_LITTLE_ENDIAN = 4
Private Const REG_EXPAND_SZ = 2
Private Const REG_LINK = 6
Private Const REG_MULTI_SZ = 7
Private Const REG_NONE = 0
Private Const REG_SZ = 1

''' Security Constants

Private Const READ_CONTROL = &H20000
Private Const READ_WRITE = 2

Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const STANDARD_RIGHTS_EXECUTE = (READ_CONTROL)
Private Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Private Const STANDARD_RIGHTS_REQUIRED = &HF0000
Private Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)

Private Const SYNCHRONIZE = &H100000

''' Registry Security Constants

Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_NOTIFY = &H10
Private Const KEY_EVENT = &H1
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_CREATE_LINK = &H20
Private Const KEY_SET_VALUE = &H2
Private Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
Private Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Private Const KEY_EXECUTE = ((KEY_READ) And (Not SYNCHRONIZE))
Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))

' Types

'' Security Types

''' Security Attributes

Private Type SECURITY_ATTRIBUTES
        nLength As Long
        lpSecurityDescriptor As Long
        bInheritHandle As Long
End Type

''' Access Control

Private Type ACL
        AclRevision As Byte
        Sbz1 As Byte
        AclSize As Integer
        AceCount As Integer
        Sbz2 As Integer
End Type

''' Security Descriptor

Private Type SECURITY_DESCRIPTOR
        Revision As Byte
        Sbz1 As Byte
        Control As Long
        Owner As Long
        Group As Long
        Sacl As ACL
        Dacl As ACL
End Type

'' Other Types

''' FileTime

Public Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type


' Registry Key Functions

Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As Any, phkResult As Long, lpdwDisposition As Long) As Long

Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long

' Registry Value Functions

'' Registry value functions declared more than once.  This is a kludge for overloading
'' that will be solved in the next version of Visual Studio, to the best of my knowledge,
'' as there will be support for overloading and polymorphism in the next version of Visual Basic

''' Standard
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long

''' String Value
Private Declare Function RegQueryValueExString Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long

''' Long Value (DO NOT PASS POINTERS)
Private Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long

''' Standard
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long

''' Pointer Value
Private Declare Function RegSetValueExPtr Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As Long, ByVal cbData As Long) As Long

''' String Value
Private Declare Function RegSetValueExString Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long

''' Long Value (DO NOT PASS POINTERS)
Private Declare Function RegSetValueExLong Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Long, ByVal cbData As Long) As Long

''' Enum (not used as of this writing...

Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Byte, lpcbData As Long) As Long

''' Delete

Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long


' VB Enum of the standard registry key constants

Public Enum StandardRegistryKeys
    HKeyClassesRoot = HKEY_CLASSES_ROOT
    HKeyCurrentConfig = HKEY_CURRENT_CONFIG
    Hkeycurrentuser = HKEY_CURRENT_USER
    HKeyDynamicData = HKEY_DYN_DATA
    HKeyLocalMachin = HKEY_LOCAL_MACHINE
    HKeyPerformanceData = HKEY_PERFORMANCE_DATA
    HKeyUsers = HKEY_USERS
End Enum

''' a handy function that ports to VB well.

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

''' Function to open the key

Private mCol As Collection

Public Property Get Count() As Long
    Count = mCol.Count
End Property

Public Property Get Item(ByVal vntIndexKey As Variant) As Long
Attribute Item.VB_MemberFlags = "200"
    On Error Resume Next
    Dim v As Variant
    Item = -1
    
    v = mCol(vntIndexKey)
    Item = v
End Property

Public Property Let Item(ByVal vntIndexKey As Variant, ByVal vData As Long)
    On Error Resume Next
    Dim v As Variant
    
    v = vData
    mCol(vntIndexKey) = v
End Property

Public Function OpenKey(ByVal uKey As StandardRegistryKeys, ByVal szSubKey As String, Optional ByVal vntIndexKey As String) As Long
    Dim l As Long, uOpened As Long, SA As SECURITY_ATTRIBUTES
    Dim d As Long
        
    l = RegCreateKeyEx(uKey, szSubKey, 0, vbNullString, 0, KEY_ALL_ACCESS, Null, uOpened, d)
    
    If l <> 0 Then
        OpenKey = -1&
        Exit Function
    Else
        OpenKey = uOpened
    End If

    On Error Resume Next
    
    If mCol Is Nothing Then
        Set mCol = New Collection
    End If
    
    If vntIndexKey = "" Then
        mCol.Add OpenKey, "_H" + Hex(OpenKey)
    Else
        mCol.Add OpenKey, vntIndexKey
    End If
End Function

''' Sub to close the key

Public Sub CloseKey(ByVal uKey As Variant)
    On Error Resume Next
    Dim sKey As String, ulKey As Long
    
    If VarType(uKey) = vbLong Then
        ulKey = uKey
        If Not mCol("_H" + Hex(ulKey)) Is Nothing Then
            mCol.Remove "_H" + Hex(ulKey)
        End If
    ElseIf VarType(uKey) = vbString Then
        sKey = uKey
        ulKey = mCol(sKey)
        If Not mCol(sKey) Is Nothing Then
            mCol.Remove sKey
        End If
    End If
    RegCloseKey (ulKey)
    
End Sub

'' Get and Set Value functions

''' Get Value

Public Function GetValue(ByVal uKey As Long, ByVal szValue As String, Optional DefaultValue As Variant) As Variant
    Dim l As Long, lType As Long
    Dim vData As Variant, lData As Long, wData As Integer
    Dim sData As String, bData() As Byte
    
    ' Null query to retrieve the type and length of data/check for existence
    
    RegQueryValueEx uKey, szValue, 0, lType, Null, l
    
    ' Failed to query value : (If DefaultValue <> Empty then create the key)
    ' then assign the Default Value and exit
    
    If l = 0 Then
        If IsEmpty(DefaultValue) = True Then
            GetValue = Empty
        Else
            vData = DefaultValue
            SetValue uKey, szValue, vData
            GetValue = DefaultValue
        End If
        
        Exit Function
    End If
    
    ' Add 2 bytes to the length to give us a little room.
    l = l + 2
    
    ' look at the return type from the Null call, and call the
    ' appropriate 'overload' of the QueryValue function
    
    ' For Strings
    If lType = REG_SZ Then
        vData = String(l, 0)
        sData = vData
        RegQueryValueExString uKey, szValue, 0, lType, sData, l
        GetValue = Mid(sData, 1, l - 1)
        Exit Function
    
    ' More than one string, call private function to parse the
    ' null terminated data
    
    ElseIf lType = REG_MULTI_SZ Then
        vData = String(l, 0)
        sData = vData
        RegQueryValueExString uKey, szValue, 0, lType, sData, l
        GetValue = GetMultiSZ(sData)
        Exit Function
        
    ' Get as string data and convert to byte data
    ' If the binary data is 2 bytes long, the value
    ' is returned as a word, if 4 bytes then a Long
    ' if 1 byte then as a single byte
    ' if 3 or 5 or more, then return as Byte() array
    
    ElseIf lType = REG_BINARY Then
        sData = String(l, 0)
        RegQueryValueExString uKey, szValue, 0, lType, sData, l
        ReDim bData(l)
        CopyMemory bData(0), ByVal StrPtr(sData), l
        
        If l = 4 Then
            CopyMemory lData, bData(0), 4
            GetValue = lData
        ElseIf l = 2 Then
            CopyMemory wData, bData(0), 2
            GetValue = wData
        ElseIf l = 1 Then
            GetValue = bData(0)
        Else
            GetValue = bData
        End If
        
        Exit Function
        
    ' Value is a dword, call the Long value function
        
    ElseIf lType = REG_DWORD Then
        RegQueryValueExLong uKey, szValue, 0, lType, lData, l
        GetValue = lData
        
    ' Retrieve the data into a string if it's anything else.
        
    Else
        vData = String(l, 0)
        RegQueryValueExString uKey, szValue, 0, lType, vData, l
        vData = Mid(vData, 1, l)
        GetValue = vData
        Exit Function
        
    End If

End Function

' Convert a Registry MultiSZ entry into a String array

Public Function GetMultiSZ(ByVal vData As String) As String()

    Dim i As Long, St() As String, j As Integer
    
    j = 0
    ReDim St(j)
    For i = 1 To Len(vData)
    
        If Mid(vData, i, 1) = Chr(0) Then
            j = j + 1
            ReDim Preserve St(j)
        Else
            St(j) = St(j) + Mid(vData, i, 1)
        End If
    Next i

    GetMultiSZ = St
End Function

' Convert a String array into Registry MultiSZ entry format

Public Function ToMultiSZ(vData() As String) As String

    Dim S As String
    Dim v As Variant
    
    For Each v In vData
        S = S + v + Chr(0)
    Next v
    S = S + Chr(0)
    ToMultiSZ = S
End Function

''' Set Value

Public Function SetValue(ByVal uKey As Long, ByVal szValue As String, vData As Variant) As Long
    Dim S As String, dwOut As Long, SM() As String
    Dim l As Long, lRet As Long
    
    '' Does not support Objects, yet....
    
    If IsObject(vData) = True Then Exit Function
    
    On Error Resume Next
    If IsEmpty(vData) Then
        DeleteValue uKey, szValue
    End If
    
    '' Call VarType() to analyze the incoming variable
    '' and store it the best way.
    
    ' If it's a string array, then we save it as a registry multisz
    
    If VarType(vData) = (vbArray + vbString) Then
        SM = vData
        S = ToMultiSZ(SM)
        lRet = RegSetValueExString(uKey, szValue, 0, REG_MULTI_SZ, S, Len(S))
    
    '' if it's a string, we save as a string
    
    ElseIf VarType(vData) = vbString Then
        S = vData + Chr(0)
        l = Len(S)
        lRet = RegSetValueExString(uKey, szValue, 0, REG_SZ, S, l)
            
    '' If it's a single byte, we save as Binary data
    
    ElseIf VarType(vData) = vbByte Then
        S = vData
        lRet = RegSetValueExString(uKey, szValue, 0, REG_BINARY, S, 1)
    
    '' On the outward bound, to make the life easier, always save
    '' Numeric values greater than a byte as a DWORD
    
    ElseIf (VarType(vData) = vbInteger) Or (VarType(vData) = vbLong) Then
        dwOut = CLng(vData)
        lRet = RegSetValueExLong(uKey, szValue, 0, REG_DWORD, dwOut, 4)
            
    
    '' If it's a boolean, we modify the standard 0 and -1, and save as a single byte
    
    ElseIf VarType(vData) = vbBoolean Then
        If (vData = True) Then
            S = Chr(1)
        Else
            S = Chr(0)
        End If
        lRet = RegSetValueExPtr(uKey, szValue, 0, REG_BINARY, StrPtr(S), 1)
    
    Else
        
        '' If it's one of these variant types, format the output to a string and save
        '' the string in the registry.  It's up to the calling function to decide
        '' how to handle this; and the same for retrieval.
        
        If VarType(vData) And (vbDate + vbDecimal + vbDouble + vbSingle + vbCurrency) Then
            S = Format(vData) + Chr(0)
            lRet = RegSetValueExString(uKey, szValue, 0, REG_SZ, S, Len(S))
        End If
    
    End If
    
    SetValue = lRet
End Function

'' Delete a value

Public Function DeleteValue(ByVal uKey As Long, ByVal szValue As String)
    RegDeleteValue uKey, szValue
End Function

'' Delete a key

Public Function DeleteKey(ByVal uKey As Long, ByVal szSubKey As String)
    RegDeleteKey uKey, szSubKey
End Function

Private Sub Class_Initialize()
    Set mCol = New Collection
End Sub

''' Called when the class is terminated.
''  Remove any keys that were not closed

Private Sub Class_Terminate()

    On Error Resume Next
    
    If Not mCol Is Nothing Then
    
        If mCol.Count <> 0 Then
        
            Dim v As Variant, l As Long
            
            For Each v In mCol
                l = v
                RegCloseKey l
            Next v
        
        End If
    End If
    
    Set mCol = Nothing
    
End Sub
